﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PivotGridCustomDataSelector
{
    using System.ComponentModel.DataAnnotations;

    public class ProductData
    {
        [DisplayAttribute(Name = "Sales Region (From Display Attribute)")]
        public string Region
        {
            get;
            set;
        }

        [DisplayAttribute(Name = "Sales Person (From Display Attribute)", Description = "The names of the sales person.")]
        public string Seller
        {
            get;
            set;
        }

        // do not create dimension over that property
        [DisplayAttribute(AutoGenerateField = false)]
        public string OrganizationName
        {
            get; set;
        }

        public string Product
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:####} pcs.")]
        public int Units
        {
            get;
            set;
        }

        [DisplayFormat(DataFormatString = "{0:C2}")]
        [DisplayAttribute(Name = "Cost (From Display Attribute)")]
        public double Cost
        {
            get;
            set;
        }

        public DateTime Date
        {
            get;
            set;
        }

        public static IEnumerable<ProductData> GenerateData()
        {
            List<ProductData> data = new List<ProductData>();

            data.Add(new ProductData { Seller = "A Mike", Product = "Product1", Cost = 10.00, Units = 5, Region = "US", Date = DateTime.Now });
            data.Add(new ProductData { Seller = "A Mike", Product = "Product2", Cost = 4.00, Units = 2, Region = "Canada", Date = DateTime.Now });
            data.Add(new ProductData { Seller = "B John", Product = "Product2", Cost = 4.00, Units = 4, Region = "US", Date = DateTime.Now });
            data.Add(new ProductData { Seller = "B John", Product = "Product3", Cost = 7.00, Units = 7, Region = "US", Date = DateTime.Now });
            data.Add(new ProductData { Seller = "C Joe", Product = "Product1", Cost = 10.00, Units = 9, Region = "US", Date = DateTime.Now });
            data.Add(new ProductData { Seller = "C Joe", Product = "Product3", Cost = 7.00, Units = 14, Region = "Canada", Date = DateTime.Now });
            data.Add(new ProductData { Seller = "D David", Product = "Product2", Cost = 4.00, Units = 1, Region = "Canada", Date = DateTime.Now });
            data.Add(new ProductData { Seller = "D David", Product = "Product3", Cost = 7.00, Units = 0, Region = "Canada", Date = DateTime.Now });

            return data;
        }
    }
}
